SystemOrganization addCategory: #'Neo-JSON-VAST-Tests'!

!KeyedCollection classSide methodsFor: '*Neo-JSON-VAST-Tests' stamp: 'marianopeck 1/31/2018 11:32'!
newFromPairs: anArray
	"Answer an instance of me associating (anArray at: i) to (anArray at: i+1)
	 for each odd i.  anArray must have an even number of entries."

	"Dictionary newFromPairs: {'Red' . Color red . 'Blue' . Color blue . 'Green' . Color green}."

	| newDictionary |
	newDictionary := self new: anArray size / 2.
	1 to: anArray size - 1 by: 2 do: [ :i | newDictionary at: (anArray at: i) put: (anArray at: i + 1) ].
	^ newDictionary! !

!Date methodsFor: '*Neo-JSON-VAST-Tests' stamp: 'marianopeck 1/31/2018 15:37'!
yyyymmdd
	^ String
		streamContents: [ :s | 
			Locale current lcTime copy
				dFmt: '%Y-%m-%d';
				printDate: self on: s ]! !

!String methodsFor: '*Neo-JSON-VAST-Tests' stamp: 'marianopeck 1/31/2018 17:02'!
includesSubString: aString

	^ (self indexOfSubCollection: aString startingAt: 1) ~~ 0
! !

!ByteArray methodsFor: '*Neo-JSON-VAST-Tests' stamp: 'marianopeck 1/31/2018 15:40'!
hex
    " an alternate implementation was | result stream |
	result := String new: self size * 2.
	stream := result writeStream.
	1 to: self size do: [ :ix | |each|
		each := self at: ix.
		stream
			nextPut: ('0123456789ABCDEF' at: each // 16 + 1);
			nextPut: ('0123456789ABCDEF' at: each \\ 16 + 1)].
    ^ result"
	
	"Answer a hexa decimal representation of the receiver"
	| string v index map |
	map := '0123456789abcdef'.
	string := String new: self size * 2. "hex"
	index := 0.
	1 to: self size do: [ :i |
		v := self at: i.
		string at: (index := index + 1) put: (map at: (v bitShift: -4) + 1).
		string at: (index := index + 1) put: (map at: (v bitAnd: 15) + 1)].
	^string
	! !

!ByteArray methodsFor: '*Neo-JSON-VAST-Tests' stamp: 'StephaneDucasse 2/28/2010 12:03'!
readHexFrom: aStream
	"Initialize the receiver from a hexadecimal string representation"
	| map v ch value |
	map := '0123456789abcdefABCDEF'.
	1 to: self size do: [ :i |
		ch := aStream next.
		v := (map indexOf: ch) - 1.
		((v between: 0 and: 15) or: [((v:= v - 6) between: 0 and: 15)]) ifFalse:[^self error: 'Hex digit 
expected'].
		value := v bitShift: 4.
		ch := aStream next.
		v := (map indexOf: ch) - 1.
		((v between: 0 and: 15) or: [((v:= v - 6) between: 0 and: 15)]) ifFalse:[^self error: 'Hex digit 
expected'].
		value := value + v.
		self at: i put: value].! !

!ArrayedCollection class methodsFor: '*Neo-JSON-VAST-Tests' stamp: ''!
new: size withAll: value 
	"Answer an instance of me, with number of elements equal to size, each 
	of which refers to the argument, value."

	^(self new: size) atAllPut: value! !

!Point methodsFor: '*Neo-JSON-VAST-Tests' stamp: 'marianopeck 1/31/2018 12:05'!
setX: xValue setY: yValue 
	x := xValue.
	y := yValue! !

!Float methodsFor: '*Neo-JSON-VAST-Tests' stamp: 'marianopeck 1/31/2018 11:29'!
closeTo: num
 	"Tell whether the receiver and arguments are close from each."
	
	^ self closeTo: num precision: 0.0001! !

!Float methodsFor: '*Neo-JSON-VAST-Tests' stamp: 'marianopeck 1/31/2018 11:29'!
closeTo: num precision: aPrecision
 	"Tell whether the receiver and arguments are close from each other given a precision"
	
	num isNumber ifFalse: [ ^ [self = num] ifError: [false]].
	self = 0.0 ifTrue: [^ num abs < aPrecision].
	num = 0 ifTrue: [^self abs < aPrecision].
	^self = num asFloat
		or: [(self - num) abs / (self abs max: num abs) < aPrecision]! !

!NeoJSONBenchmark class methodsFor: '*Neo-JSON-VAST-Tests' stamp: 'MarianoMartinezPeck 1/30/2018 10:06'!
new
	^super new initialize! !

!Number methodsFor: '*Neo-JSON-VAST-Tests' stamp: 'marianopeck 2/1/2018 09:42'!
closeTo: num
	"Tell whether the receiver and arguments are close from each."

	num isFloat ifTrue: [ ^ num closeTo: self asFloat ].
	^ [ self = num ] on: Error do: [ :ex | false ]! !

!Number methodsFor: '*Neo-JSON-VAST-Tests' stamp: 'marianopeck 1/31/2018 11:29'!
closeTo: num precision: aPrecision
	"are these two numbers close?"

	num isFloat ifTrue: [ ^ num closeTo: self asFloat precision: aPrecision ].
	^ [ self = num ] ifError: [ false ]! !

!Number methodsFor: '*Neo-JSON-VAST-Tests' stamp: 'tbn 10/24/2012 15:32'!
hour
 
 	^ self hours! !

!Number methodsFor: '*Neo-JSON-VAST-Tests' stamp: 'brp 5/16/2003 07:56'!
hours
 
 	^ Duration hours: self! !
